{ KOL MCK } // Do not remove this line!
{$DEFINE KOL_MCK}
unit MainUnit;

interface

{$IFDEF KOL_MCK}
uses Windows, Messages, ShellAPI, KOL, KOLSPCDriveComboBox, KOLSPCDirectoryListBox, KOLSPCFileListBox {$IFNDEF KOL_MCK}, mirror, Classes,  Controls, mckCtrls,  mckSPCDriveComboBox,  mckSPCDirectoryListBox,  mckSPCFileListBox,
  mckObjs {$ENDIF}, spcAboutDialog;
{$ELSE}
{$I uses.inc}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;
{$ENDIF}

type
  {$IFDEF KOL_MCK}
  {$I MCKfakeClasses.inc}
  PForm1 = ^TForm1;
  TForm1 = object(TObj)
    Form: PControl;
  {$ELSE not_KOL_MCK}
  TForm1 = class(TForm)
  {$ENDIF KOL_MCK}
    KOLProject1: TKOLProject;
    KOLForm1: TKOLForm;
    Panel1: TKOLPanel;
    Panel2: TKOLPanel;
    SPCDriveComboBox1: TSPCDriveComboBox;
    SPCDirectoryListBox1: TSPCDirectoryListBox;
    SPCFileListBox1: TSPCFileListBox;
    Panel3: TKOLPanel;
    Label1: TKOLLabel;
    ScrollBox1: TKOLScrollBox;
    PaintBox1: TKOLPaintBox;
    MainMenu1: TKOLMainMenu;
    OpenSaveDialog1: TKOLOpenSaveDialog;
    OpenDirDialog1: TKOLOpenDirDialog;
    Timer1: TKOLTimer;
    procedure LoadSprite(FName: string; var BMP: PBitmap);
    procedure DoSave;
    procedure SPCDriveComboBox1Change(Sender: PObj);
    procedure SPCDirectoryListBox1MouseDblClk(Sender: PControl;
      var Mouse: TMouseEventData);
    procedure SPCFileListBox1SelChange(Sender: PObj);
    procedure KOLForm1FormCreate(Sender: PObj);
    procedure PaintBox1Paint(Sender: PControl; DC: HDC);
    procedure KOLForm1N5Menu(Sender: PMenu; Item: Integer);
    procedure PaintBox1Click(Sender: PObj);
    procedure KOLForm1N2Menu(Sender: PMenu; Item: Integer);
    procedure Timer1Timer(Sender: PObj);
    procedure KOLForm1N3Menu(Sender: PMenu; Item: Integer);
    procedure KOLForm1Show(Sender: PObj);
    procedure KOLForm1N6Menu(Sender: PMenu; Item: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  procedure Colors16To24(fW: Word; var fR,fG,fB: Byte);

var
  Form1 {$IFDEF KOL_MCK} : PForm1 {$ELSE} : TForm1 {$ENDIF} ;
  ADDBuffer: array[0..3]of Byte=(0,0,0,0);
  fBitmap: PBitmap;
  SaveDir,OpenDir: string;
  id: array[1..2]of char;
  BMPHeader: record
               FullSize: LongInt;
               _H1: LongInt;
               _C1: LongInt;
               _C2: LongInt;
               X: LongInt;
               Y: LongInt;
               _C3: Word;
               _C4: Word;
               _H2: LongInt;
               _H3: LongInt;
               DataSize1: LongInt;
               DataSize2: LongInt;
               _C5: array[1..8]of Byte;
             end;

{$IFDEF KOL_MCK}
procedure NewForm1( var Result: PForm1; AParent: PControl );
{$ENDIF}

implementation

{$IFNDEF KOL_MCK} {$R *.DFM} {$ENDIF}

{$IFDEF KOL_MCK}
{$I MainUnit_1.inc}
{$ENDIF}

procedure Colors16To24(fW: Word; var fR,fG,fB: Byte);
var
  ffW,TfR,TfG,TfB: Word;
  ffG: Word;
  ffL,ffR: Word;
begin
  TfR:=5;
  TfG:=6;
  TfB:=5;
  ffG:=fW;
  ffW:=ffG shl (16-TfR);
  ffW:=ffW shr (16-TfR);
  fR:=ffW;
  ffW:=ffG shl (16-TfG-TfR);
  ffW:=ffW shr (16-TfG);
  fG:=ffW;
  ffW:=ffG shl (16-TfG-TfR-TfB);
  ffW:=ffW shr (16-TfB);
  fB:=ffW;
end;

procedure TForm1.SPCDriveComboBox1Change(Sender: PObj);
begin
  SPCDirectoryListBox1.Path:=SPCDriveComboBox1.Drive;
end;

procedure TForm1.SPCDirectoryListBox1MouseDblClk(Sender: PControl;
  var Mouse: TMouseEventData);
begin
  SPCFileListBox1.Path:=SPCDirectoryListBox1.Path;
end;

procedure TForm1.LoadSprite;
var
  F,FData,FBmp: PStream;
  fWidth,fHeight,SavePosition,ROffset,fTotalRowLength: LongInt;
  x,y: LongInt;
  Buffer: array[0..2047]of Word;
  RGBBuffer: array[0..2047]of record
                                R,G,B: Byte;
                              end;
  fR,fG,fB,Add: Byte;
  fTemp,FloodFlag: Word;
  Flag,SpriteOffset: LongInt;
begin
  F:=NewReadFileStream(FName);
  FBmp:=NewMemoryStream;
  FData:=NewMemoryStream;
  F.Seek($1E,spBegin);
  F.Read(FloodFlag,2);
  F.Seek($14,spBegin);
  F.Read(fWidth,4);
  F.Read(fHeight,4);
  F.Seek($24,spBegin);
  F.Read(Flag,4);
  if Flag<>0 then
  begin
    F.Read(Flag,4);
    SpriteOffset:=Flag+$40;
  end else SpriteOffset:=$40;
  BMP.Width:=0;
  BMP.Height:=0;
  Label1.Caption:=': '+Int2Str(fWidth)+'x'+Int2Str(fHeight);
  BMP.Width:=fWidth;
  BMP.Height:=fWidth;
  if Frac(fWidth/4)=0.75 then Add:=3 else
  if Frac(fWidth/4)=0.50 then Add:=2 else
  if Frac(fWidth/4)=0.25 then Add:=1 else
  Add:=0;
  BMPHeader.X:=fWidth;
  BMPHeader.Y:=fHeight;
  BMPHeader._C1:=$00000036;
  BMPHeader._C2:=$00000028;
  BMPHeader._C3:=$0001;
  BMPHeader._C4:=$0018;
  BMPHeader.DataSize1:=$0B12;
  BMPHeader.DataSize2:=$0B12;
  BMPHeader.FullSize:=((fWidth+Add)*fHeight)*3+$36;
  FBmp.Write(ID,2);
  FBmp.Write(BMPHeader,SizeOf(BMPHeader));
  F.Seek(SpriteOffset,spBegin);
  SavePosition:=SpriteOffset;
  if FloodFlag=1 then
  begin
    for y:=0 to fHeight-1 do
    begin
      F.Seek(SavePosition,spBegin);
      F.Read(ROffset,4);
      SavePosition:=F.Position;
      F.Seek(ROffset+SpriteOffset,spBegin);
      fTotalRowLength:=0;
      repeat
        F.Read(fTemp,2);
        if fTemp>0 then
        begin
          for x:=1 to fTemp div 2 do
          begin
            RGBBuffer[x-1].R:=$00;
            RGBBuffer[x-1].G:=$00;
            RGBBuffer[x-1].B:=$00;
          end;
          FData.Write(RGBBuffer,(fTemp div 2)*3);
        end;
        fTotalRowLength:=fTotalRowLength+fTemp div 2;
        if fTotalRowLength<fWidth then
        begin
          F.Read(fTemp,2);
          fTotalRowLength:=fTotalRowLength+fTemp div 2;
          F.Read(Buffer,fTemp);
          for x:=1 to fTemp div 2 do
          begin
            Colors16To24(Buffer[x-1],RGBBuffer[x-1].R,RGBBuffer[x-1].G,RGBBuffer[x-1].B);
            RGBBuffer[x-1].R:=RGBBuffer[x-1].R*8;
            RGBBuffer[x-1].G:=RGBBuffer[x-1].G*4;
            RGBBuffer[x-1].B:=RGBBuffer[x-1].B*8;
          end;
          FData.Write(RGBBuffer,(fTemp div 2)*3);
        end;
      until fTotalRowLength=fWidth;
      if Add>0 then
      FData.Write(ADDBuffer,Add);
    end;
  end else
  begin
    for y:=0 to fHeight-1 do
    begin
      F.Read(Buffer,fWidth*2);
      for x:=1 to fWidth do
      begin
        Colors16To24(Buffer[x-1],RGBBuffer[x-1].R,RGBBuffer[x-1].G,RGBBuffer[x-1].B);
        RGBBuffer[x-1].R:=RGBBuffer[x-1].R*8;
        RGBBuffer[x-1].G:=RGBBuffer[x-1].G*4;
        RGBBuffer[x-1].B:=RGBBuffer[x-1].B*8;
      end;
      FData.Write(RGBBuffer,fWidth*3);
      if Add>0 then
      FData.Write(ADDBuffer,Add);
    end;
  end;
  for y:=0 to fHeight-1 do
  begin
    FData.Seek((fHeight-y)*(fWidth*3+Add),spBegin);
    Stream2Stream(FBmp,FData,fWidth*3+Add);
  end;
  FBmp.Seek(0,spBegin);
  BMP.LoadFromStream(FBmp);
  FData.Free;
  FBmp.Free;
  F.Free;
end;

procedure TForm1.SPCFileListBox1SelChange(Sender: PObj);
begin
  LoadSprite(SPCFileListBox1.Path+SPCFileListBox1.GetFileName, fBitmap);
  PaintBox1.OnPaint(@Self,PaintBox1.Handle);
end;

procedure TForm1.KOLForm1FormCreate(Sender: PObj);
begin
  fBitmap:=NewBitmap(1,1);
  id[1]:='B';
  id[2]:='M';
  GetDir(0,SaveDir);
  GetDir(0,OpenDir);
end;

procedure TForm1.PaintBox1Paint(Sender: PControl; DC: HDC);
begin
  PaintBox1.Width:=fBitmap.Width;
  PaintBox1.Height:=fBitmap.Height;
  fBitmap.Draw(PaintBox1.Canvas.Handle,0,0);
end;

procedure TForm1.KOLForm1N5Menu(Sender: PMenu; Item: Integer);
begin
  Form.Close;
end;

procedure TForm1.DoSave;
var
  fNewName: string;
begin
  fNewName:=Copy(SPCFileListBox1.GetFileName,1,Pos('.',SPCFileListBox1.GetFileName)-1);
  OpenSaveDialog1.InitialDir:=SaveDir;
  OpenSaveDialog1.Filename:=fNewName;
  if OpenSaveDialog1.Execute then
  begin
    fBitmap.SaveToFile(OpenSaveDialog1.FileName);
    SaveDir:=ExtractFilePath(OpenSaveDialog1.FileName);
  end;
end;

procedure TForm1.PaintBox1Click(Sender: PObj);
begin
  DoSave;
end;

procedure TForm1.KOLForm1N2Menu(Sender: PMenu; Item: Integer);
begin
  DoSave;
end;

procedure TForm1.Timer1Timer(Sender: PObj);
begin
  if SPCFileListBox1.TotalSelected>0 then
  begin
    MainMenu1.ItemEnabled[1]:=True;
    MainMenu1.ItemEnabled[2]:=True;
  end else
  begin
    MainMenu1.ItemEnabled[1]:=False;
    MainMenu1.ItemEnabled[2]:=False;
  end;
end;

procedure TForm1.KOLForm1N3Menu(Sender: PMenu; Item: Integer);
var
  i: Integer;
  TempBMP: PBitmap;
begin
  OpenDirDialog1.InitialPath:=OpenDir;
  if OpenDirDialog1.Execute then
  begin
    OpenDir:=OpenDirDialog1.Path;
    TempBMP:=NewBitmap(1,1);
    for i:=0 to SPCFileListBox1.Count do
    if SPCFileListBox1.Selected[i] then
    begin
      LoadSprite(SPCFileListBox1.Path+SPCFileListBox1.Items[i], TempBMP);
      TempBMP.SaveToFile(OpenDir+'\'+Copy(SPCFileListBox1.Items[i],1,Pos('.',SPCFileListBox1.Items[i]))+'bmp');
    end;
    TempBMP.Free;
  end;
end;

procedure TForm1.KOLForm1Show(Sender: PObj);
begin
  InitAboutDialog(Form);
end;

procedure TForm1.KOLForm1N6Menu(Sender: PMenu; Item: Integer);
begin
  ShowAboutDialog('FOD XBM Converter v1.0','2  2002.',' ','collapse_forever@mail.ru','http://extractor.far.ru');
end;

end.
